diff -r e16bdc0054ce src/town_cmd.cpp
--- a/src/town_cmd.cpp
+++ b/src/town_cmd.cpp
@@ -52,6 +52,18 @@
 
 #include "safeguards.h"
 
+bool _cb_enabled = false;
+uint _cb_storage = 0;
+uint CBREQ[NUM_CARGO] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};//CB
+uint CBFROM[NUM_CARGO] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};//CB
+uint CBDECAY[NUM_CARGO] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};//CB
+uint days_in_month[] = {31, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};//CB
+void CB_UpdateTownStorage(Town *t); //CB
+
+const Money NOVAPOLIS_COMPANY_MONEY_THRESHOLD = INT64_MAX >> 4;
+TownsGrowthTilesIndex _towns_growth_tiles_last_month;
+TownsGrowthTilesIndex _towns_growth_tiles;
+
 TownID _new_town_id;
 uint32 _town_cargoes_accepted; ///< Bitmap of all cargoes accepted by houses.
 
@@ -162,6 +174,26 @@
 	return Town::Get(index);
 }
 
+ /**
+ * Updates the town label of the town after changes in rating. The colour scheme is:
+ * Red: Appalling and Very poor ratings.
+ * Orange: Poor and mediocre ratings.
+ * Yellow: Good rating.
+ * White: Very good rating (standard).
+ * Green: Excellent and outstanding ratings.
+ */
+void Town::UpdateLabel()
+{
+	if (!(_game_mode == GM_EDITOR) && (_local_company < MAX_COMPANIES)) {
+		int r = this->ratings[_local_company];
+		if     (r < RATING_VERYPOOR) this->town_label = 0; // Appalling and Very Poor, RED
+		else if(r < RATING_MEDIOCRE) this->town_label = 1; // Poor and Mediocre, ORANGE
+		else if(r < RATING_GOOD)     this->town_label = 2; // Good, YELLOW
+		else if(r < RATING_VERYGOOD) this->town_label = 3; // Very Good, WHITE
+		else                         this->town_label = 4; // Excellent and Outstanding, GREEN
+	}
+}
+
 /**
  * Get the cost for removing this house
  * @return the cost (inflation corrected etc)
@@ -373,6 +405,7 @@
  */
 void Town::UpdateVirtCoord()
 {
+	this->UpdateLabel();
 	Point pt = RemapCoords2(TileX(this->xy) * TILE_SIZE, TileY(this->xy) * TILE_SIZE);
 	SetDParam(0, this->index);
 	SetDParam(1, this->cache.population);
@@ -381,6 +414,7 @@
 		STR_VIEWPORT_TOWN);
 
 	SetWindowDirty(WC_TOWN_VIEW, this->index);
+	SetWindowDirty(WC_CB_TOWN, this->index);
 }
 
 /** Update the virtual coords needed to draw the town sign for all towns. */
@@ -400,6 +434,8 @@
  */
 static void ChangePopulation(Town *t, int mod)
 {
+	// if(mod > 0 && t->houses_construction > 0) t->houses_construction--;
+
 	t->cache.population += mod;
 	InvalidateWindowData(WC_TOWN_VIEW, t->index); // Cargo requirements may appear/vanish for small populations
 	t->UpdateVirtCoord();
@@ -438,8 +474,13 @@
 	if (IsHouseCompleted(tile)) {
 		/* Now that construction is complete, we can add the population of the
 		 * building to the town. */
-		ChangePopulation(Town::GetByTile(tile), HouseSpec::Get(GetHouseType(tile))->population);
+		HouseID house_id = GetHouseType(tile);
+		Town *town = Town::GetByTile(tile);
+		const HouseSpec *hs = HouseSpec::Get(house_id);
+		ChangePopulation(town, hs->population);
 		ResetHouseAge(tile);
+		if (hs->building_flags & BUILDING_HAS_1_TILE)
+			town->houses_construction--;
 	}
 	MarkTileDirtyByTile(tile);
 }
@@ -540,7 +581,13 @@
 		ClearTownHouse(t, tile);
 
 		/* Rebuild with another house? */
-		if (GB(r, 24, 8) >= 12) BuildTownHouse(t, tile);
+		if (GB(r, 24, 8) >= 12 && BuildTownHouse(t, tile)) {
+			t->houses_reconstruction++;
+			UpdateTownGrowthTile(tile, TGTS_RH_REBUILT);
+		} else {
+			t->houses_demolished++;
+			UpdateTownGrowthTile(tile, TGTS_RH_REMOVED);
+		}
 	}
 
 	cur_company.Restore();
@@ -568,6 +615,11 @@
 
 	ChangeTownRating(t, -rating, RATING_HOUSE_MINIMUM, flags);
 	if (flags & DC_EXEC) {
+		if (_current_company == COMPANY_FIRST &&
+				Company::Get(_current_company)->money > NOVAPOLIS_COMPANY_MONEY_THRESHOLD) {
+			if (t->growing) t->cb_houses_removed++;
+			UpdateTownGrowthTile(tile, t->growing ? TGTS_CB_HOUSE_REMOVED: TGTS_CB_HOUSE_REMOVED_NOGROW);
+		}
 		ClearTownHouse(t, tile);
 	}
 
@@ -658,6 +710,7 @@
 	bool house_completed = IsHouseCompleted(tile);
 
 	td->str = hs->building_name;
+	td->population = hs->population;
 
 	uint16 callback_res = GetHouseCallback(CBID_HOUSE_CUSTOM_NAME, house_completed ? 1 : 0, 0, house, Town::GetByTile(tile), tile);
 	if (callback_res != CALLBACK_FAILED && callback_res != 0x400) {
@@ -777,19 +830,97 @@
 
 static bool GrowTown(Town *t);
 
+static void DoRegularFunding(Town *t)
+{
+	bool fund_regularly = HasBit(t->fund_regularly, _local_company);
+	bool do_powerfund = HasBit(t->do_powerfund, _local_company);
+
+	if (do_powerfund && (_settings_client.gui.powerfund_money > Company::Get(_local_company)->money ||
+		    _settings_client.gui.powerfund_houses < t->cache.num_houses)) {
+	    do_powerfund = false;
+	}
+
+	if (!fund_regularly && !do_powerfund)
+		return;
+
+	if (_local_company == COMPANY_SPECTATOR)
+		return;
+
+	if (CB_Enabled() && !t->growing)
+		return;
+
+	uint16 gr = (t->growth_rate & ~TOWN_GROW_RATE_CUSTOM);
+
+	// Funding with grow_counter == 1 doesn't speed up next house building,
+	// so trying to avoid it. This means no powerfunding with gr <= 1, and no
+	// regular funding with grow_counter == 1 unless gr is also 1
+	// (we need to fund anyway even if it doesn't speed up next house)
+	// And in case town is not growing ignore grow_counter and growth_rate
+	// completely (it will start growing once we fund it)
+	bool not_growing = !HasBit(t->flags, TOWN_IS_GROWING);
+	if ((fund_regularly && t->fund_buildings_months == 0 &&
+	    	((t->grow_counter > 0 && (t->grow_counter > 1 || gr == 1)) || not_growing)) ||
+		(do_powerfund && gr > 1 && (t->grow_counter == gr || not_growing))) {
+
+		CompanyByte old = _current_company;
+		_current_company = _local_company;
+		DoCommandP(t->xy, t->index, HK_FUND, CMD_DO_TOWN_ACTION | CMD_NO_ESTIMATE);
+		_current_company = old;
+	}
+}
+
+static void DoRegularAdvertising(Town *t) {
+	if (!HasBit(t->advertise_regularly, _local_company))
+		return;
+
+	if (t->ad_ref_goods_entry == NULL) {
+		// Pick as ref station and cargo with min rating
+		const Station *st;
+		FOR_ALL_STATIONS(st) {
+			if (st->owner == _local_company && DistanceManhattan(t->xy, st->xy) <= 20) {
+				for (CargoID i = 0; i < NUM_CARGO; i++)
+					if (st->goods[i].HasRating() && (t->ad_ref_goods_entry == NULL ||
+					    	t->ad_ref_goods_entry->rating < st->goods[i].rating)) {
+						t->ad_ref_goods_entry = &st->goods[i];
+					}
+			}
+		}
+
+		if (t->ad_ref_goods_entry == NULL)
+			return;
+	}
+
+	if (t->ad_ref_goods_entry->rating >= t->ad_rating_goal)
+		return;
+
+    CompanyByte old = _current_company;
+    _current_company = _local_company;
+    DoCommandP(t->xy, t->index, HK_LADVERT, CMD_DO_TOWN_ACTION | CMD_NO_ESTIMATE);
+    _current_company = old;
+}
+
 static void TownTickHandler(Town *t)
 {
 	if (HasBit(t->flags, TOWN_IS_GROWING)) {
 		int i = t->grow_counter - 1;
+		uint16 houses_prev = t->cache.num_houses;
 		if (i < 0) {
 			if (GrowTown(t)) {
 				i = t->growth_rate & (~TOWN_GROW_RATE_CUSTOM);
+				if (t->cache.num_houses <= houses_prev && (t->growing || !CB_Enabled())){
+					t->houses_skipped++;
+				}
 			} else {
+				if (t->growing || !CB_Enabled()){
+					t->cycles_skipped++;
+				}
 				i = 0;
 			}
 		}
 		t->grow_counter = i;
 	}
+	DoRegularFunding(t);
+	DoRegularAdvertising(t);
 }
 
 void OnTick_Town()
@@ -1346,11 +1477,12 @@
  * @param tile to inquiry
  * @return true if town expansion was possible
  */
-static bool GrowTownAtRoad(Town *t, TileIndex tile)
+static bool GrowTownAtRoad(Town *t, TileIndex start_tile, TileIndex &tile)
 {
 	/* Special case.
 	 * @see GrowTownInTile Check the else if
 	 */
+	tile = start_tile;
 	DiagDirection target_dir = DIAGDIR_END; // The direction in which we want to extend the town
 
 	assert(tile < MapSize());
@@ -1469,8 +1601,14 @@
 	const TileIndexDiffC *ptr;
 	for (ptr = _town_coord_mod; ptr != endof(_town_coord_mod); ++ptr) {
 		if (GetTownRoadBits(tile) != ROAD_NONE) {
-			bool success = GrowTownAtRoad(t, tile);
+			uint16 houses_prev = t->cache.num_houses;
+			TileIndex end_tile;
+			bool success = GrowTownAtRoad(t, tile, end_tile);
 			cur_company.Restore();
+			if (!success)
+				UpdateTownGrowthTile(end_tile, TGTS_CYCLE_SKIPPED);
+			else if (t->cache.num_houses <= houses_prev)
+				UpdateTownGrowthTile(end_tile, TGTS_HOUSE_SKIPPED);
 			return success;
 		}
 		tile = TILE_ADD(tile, ToTileIndexDiff(*ptr));
@@ -1485,6 +1623,7 @@
 			if (!IsTileType(tile, MP_HOUSE) && IsTileFlat(tile)) {
 				if (DoCommand(tile, 0, 0, DC_AUTO | DC_NO_WATER, CMD_LANDSCAPE_CLEAR).Succeeded()) {
 					DoCommand(tile, GenRandomRoadBits(), t->index, DC_EXEC | DC_AUTO, CMD_BUILD_ROAD);
+					UpdateTownGrowthTile(tile, TGTS_HOUSE_SKIPPED);
 					cur_company.Restore();
 					return true;
 				}
@@ -1493,6 +1632,7 @@
 		}
 	}
 
+	UpdateTownGrowthTile(tile, TGTS_CYCLE_SKIPPED);
 	cur_company.Restore();
 	return false;
 }
@@ -1546,6 +1686,123 @@
 	t->supplied[CT_MAIL].old_max = t->cache.population >> 4;
 }
 
+//CB
+
+bool CB_Enabled(){
+	return _cb_enabled;
+}
+void CB_SetCB(bool cb){
+	_cb_enabled = cb;
+	if(!_cb_enabled){
+		CB_ResetRequirements();
+	}
+}
+
+uint CB_GetStorage() {
+	return _cb_storage;
+}
+
+void CB_SetStorage(uint storage){
+	_cb_storage = storage;
+}
+
+void CB_SetRequirements(CargoID cargo, uint req, uint from, uint decay){
+	CBREQ[cargo] = req;
+	CBFROM[cargo] = from;
+	CBDECAY[cargo] = decay;
+}
+void CB_ResetRequirements() {
+	for(CargoID cargo = 0; cargo < NUM_CARGO; cargo++){
+		CB_SetRequirements(cargo, 0, 0, 0);
+	}
+}
+uint CB_GetReq(CargoID cargo){
+	return CBREQ[cargo];
+}
+uint CB_GetFrom(CargoID cargo){
+	return CBFROM[cargo];
+}
+uint CB_GetDecay(CargoID cargo){
+	return CBDECAY[cargo];
+}
+int CB_GetTownReq(uint population, uint req, uint from, bool from_non_important, bool prev_month)
+{
+	if (req > 0 && (population >= from || from_non_important)) {
+		uint leap = 0;
+		Month month = _cur_month;
+		if (!prev_month) month++;
+		if(month == 2){
+			if((_cur_year % 4 == 0 && _cur_year % 100 != 0) || _cur_year % 400 == 0) leap = 1;
+		}
+		uint days_this_month = days_in_month[month] + leap;
+		// x cargo for 1000 people
+		return population * req * days_this_month / 31000; // 31 days divide by 1000 (pop)
+	}
+	return 0;
+}
+uint CB_GetMaxTownStorage(uint32 population, uint req)
+{
+	return req > 0 ? (population * req * _cb_storage / 1000) : 0;
+}
+
+uint CB_GetMaxTownStorage(Town *town, uint cargo) {
+	return CBREQ[cargo] > 0 ? (town->cache.population * CBREQ[cargo] * _cb_storage / 1000) : 0;
+}
+
+void CB_UpdateTownStorage(Town *t)
+{
+	InvalidateWindowData(WC_CB_TOWN, t->index);
+	t->growing = true;
+	if (!HasBit(t->flags, TOWN_IS_GROWING)) { //dont grow if not funded or missing transportation
+		t->growing = false;
+	}
+	for (uint i = 0; i < NUM_CARGO ; i++) {
+		if(CBREQ[i] == 0) continue;
+
+		t->storage[i] += t->new_act_cargo[i]; // add accumulated last month
+		t->storage[i] -= CB_GetTownReq(t->cache.population, CBREQ[i], CBFROM[i], false, true); //subtract monthly req
+		t->storage[i] = min((int)CB_GetMaxTownStorage(t->cache.population, CBREQ[i]), t->storage[i]); //check max storage
+
+		if (t->storage[i] < 0) {
+			t->growing = false;
+			t->delivered_enough[i] = false;
+			t->storage[i] = 0;
+		}
+		else t->delivered_enough[i] = true;
+
+		if (CBDECAY[i] == 100 && t->storage[i] > 0) {
+			t->storage[i] = 0;
+		}
+		else {
+			t->storage[i] *= (100 - CBDECAY[i]);
+			t->storage[i] /= 100;
+		}
+		t->act_cargo[i] = t->new_act_cargo[i];
+		t->new_act_cargo[i] = 0;
+	}
+
+	if (_settings_game.game_creation.landscape == LT_TROPIC) {
+		if (GetTropicZone(t->xy) == TROPICZONE_DESERT && (t->received[TE_FOOD].old_act <= 0 || t->received[TE_WATER].old_act <= 0) && t->cache.population > 60) {
+			t->growing = false;
+		}
+	}
+	else if (_settings_game.game_creation.landscape == LT_ARCTIC) {
+		if (TilePixelHeight(t->xy) >= GetSnowLine() && t->received[TE_FOOD].old_act <= 0 && t->cache.population > 90) {
+			t->growing = false;
+		}
+	}
+}
+//CB
+
+void UpdateTownGrowthTile(TileIndex tile, TownGrowthTileState state) {
+	_towns_growth_tiles[tile] = max(_towns_growth_tiles[tile], state);
+}
+
+void ResetTownsGrowthTiles() {
+	_towns_growth_tiles_last_month.clear();
+	_towns_growth_tiles.clear();
+}
+
 /**
  * Does the actual town creation.
  *
@@ -1581,6 +1838,23 @@
 	}
 
 	t->fund_buildings_months = 0;
+	//CB
+	t->growing = false;
+	for (uint i = 0; i < NUM_CARGO ; i++) {
+		t->storage[i] = 0;
+		t->act_cargo[i] = 0;
+		t->new_act_cargo[i] = 0;
+		t->delivered_enough[i] = false;
+	}
+	t->houses_construction = 0;
+	t->houses_reconstruction = 0;
+	t->houses_demolished = 0;
+	t->fund_regularly = 0;
+	t->do_powerfund = 0;
+	t->advertise_regularly = 0;
+	t->ad_rating_goal = 95;
+	t->ad_ref_goods_entry = NULL;
+	//CB
 
 	for (uint i = 0; i != MAX_COMPANIES; i++) t->ratings[i] = RATING_INITIAL;
 
@@ -1601,6 +1875,7 @@
 	}
 	t->townnameparts = townnameparts;
 
+	t->town_label = 3;
 	t->UpdateVirtCoord();
 	InvalidateWindowData(WC_TOWN_DIRECTORY, 0, 0);
 
@@ -2365,6 +2640,8 @@
 
 		/* build the house */
 		t->cache.num_houses++;
+		t->cache.potential_pop += hs->population;
+		t->houses_construction++;
 
 		/* Special houses that there can be only one of. */
 		t->flags |= oneof;
@@ -2380,12 +2657,14 @@
 
 			if (construction_stage == TOWN_HOUSE_COMPLETED) {
 				ChangePopulation(t, hs->population);
+				t->houses_construction--;
 			} else {
 				construction_counter = GB(r, 2, 2);
 			}
 		}
 
 		MakeTownHouse(tile, t, construction_counter, construction_stage, house, random_bits);
+		UpdateTownGrowthTile(tile, TGTS_NEW_HOUSE);
 		UpdateTownRadius(t);
 		UpdateTownCargoes(t, tile);
 
@@ -2452,9 +2731,12 @@
 	/* Remove population from the town if the house is finished. */
 	if (IsHouseCompleted(tile)) {
 		ChangePopulation(t, -hs->population);
+	} else {
+		t->houses_construction--;
 	}
 
 	t->cache.num_houses--;
+	t->cache.potential_pop -= hs->population;
 
 	/* Clear flags for houses that only may exist once/town. */
 	if (hs->building_flags & BUILDING_IS_CHURCH) {
@@ -2618,6 +2900,7 @@
 		}
 		UpdateTownGrowRate(t);
 		InvalidateWindowData(WC_TOWN_VIEW, p1);
+		InvalidateWindowData(WC_CB_TOWN, p1);
 	}
 
 	return CommandCost();
@@ -2908,6 +3191,7 @@
 		UpdateTownGrowRate(t);
 
 		SetWindowDirty(WC_TOWN_VIEW, t->index);
+		SetWindowDirty(WC_CB_TOWN, t->index);
 	}
 	return CommandCost();
 }
@@ -2964,6 +3248,7 @@
 			 */
 			if (t->ratings[_current_company] > RATING_BRIBE_DOWN_TO) {
 				t->ratings[_current_company] = RATING_BRIBE_DOWN_TO;
+				t->UpdateVirtCoord();
 				SetWindowDirty(WC_TOWN_AUTHORITY, t->index);
 			}
 		} else {
@@ -3096,13 +3381,16 @@
 		t->ratings[i] = Clamp(t->ratings[i], RATING_MINIMUM, RATING_MAXIMUM);
 	}
 
+	t->UpdateVirtCoord();
 	SetWindowDirty(WC_TOWN_AUTHORITY, t->index);
 }
 
 static void UpdateTownGrowRate(Town *t)
 {
 	ClrBit(t->flags, TOWN_IS_GROWING);
+	t->growing_by_chance = false;
 	SetWindowDirty(WC_TOWN_VIEW, t->index);
+	SetWindowDirty(WC_CB_TOWN, t->index);
 
 	if (_settings_game.economy.town_growth_rate == 0 && t->fund_buildings_months == 0) return;
 
@@ -3126,6 +3414,7 @@
 	if ((t->growth_rate & TOWN_GROW_RATE_CUSTOM) != 0) {
 		if (t->growth_rate != TOWN_GROW_RATE_CUSTOM_NONE) SetBit(t->flags, TOWN_IS_GROWING);
 		SetWindowDirty(WC_TOWN_VIEW, t->index);
+		SetWindowDirty(WC_CB_TOWN, t->index);
 		return;
 	}
 
@@ -3156,6 +3445,7 @@
 	} else {
 		m = _grow_count_values[1][min(n, 5)];
 		if (n == 0 && !Chance16(1, 12)) return;
+		if (n == 0) t->growing_by_chance = true;
 	}
 
 	/* Use the normal growth rate values if new buildings have been funded in
@@ -3170,6 +3460,7 @@
 
 	SetBit(t->flags, TOWN_IS_GROWING);
 	SetWindowDirty(WC_TOWN_VIEW, t->index);
+	SetWindowDirty(WC_CB_TOWN, t->index);
 }
 
 static void UpdateTownAmounts(Town *t)
@@ -3179,6 +3470,7 @@
 	if (t->fund_buildings_months != 0) t->fund_buildings_months--;
 
 	SetWindowDirty(WC_TOWN_VIEW, t->index);
+	SetWindowDirty(WC_CB_TOWN, t->index);
 }
 
 static void UpdateTownUnwanted(Town *t)
@@ -3347,6 +3639,7 @@
 	} else {
 		SetBit(t->have_ratings, _current_company);
 		t->ratings[_current_company] = rating;
+		t->UpdateVirtCoord();
 		SetWindowDirty(WC_TOWN_AUTHORITY, t->index);
 	}
 }
@@ -3392,6 +3685,9 @@
 {
 	Town *t;
 
+	_towns_growth_tiles_last_month = _towns_growth_tiles;
+	_towns_growth_tiles.clear();
+
 	FOR_ALL_TOWNS(t) {
 		if (t->road_build_months != 0) t->road_build_months--;
 
@@ -3399,11 +3695,24 @@
 			if (--t->exclusive_counter == 0) t->exclusivity = INVALID_COMPANY;
 		}
 
+		if (CB_Enabled() && !t->larger_town) CB_UpdateTownStorage(t); //CB
+
 		UpdateTownAmounts(t);
 		UpdateTownRating(t);
 		UpdateTownGrowRate(t);
 		UpdateTownUnwanted(t);
 		UpdateTownCargoes(t);
+
+		DoRegularFunding(t);
+
+		t->houses_demolished = 0;
+		t->houses_reconstruction = 0;
+		t->houses_skipped_last_month = t->houses_skipped - t->houses_skipped_prev;
+		t->houses_skipped_prev = t->houses_skipped;
+		t->cycles_skipped_last_month = t->cycles_skipped - t->cycles_skipped_prev;
+		t->cycles_skipped_prev = t->cycles_skipped;
+		t->cb_houses_removed_last_month = t->cb_houses_removed - t->cb_houses_removed_prev;
+		t->cb_houses_removed_prev = t->cb_houses_removed;
 	}
 
 	UpdateTownCargoBitmap();
